;Software License Agreement (BSD License)
;
;Copyright (c) 1997-2008, David Lindauer, (LADSoft).
;All rights reserved.
;
;Redistribution and use of this software in source and binary forms, with or without modification, are
;permitted provided that the following conditions are met:
;
;* Redistributions of source code must retain the above
;  copyright notice, this list of conditions and the
;  following disclaimer.
;
;* Redistributions in binary form must reproduce the above
;  copyright notice, this list of conditions and the
;  following disclaimer in the documentation and/or other
;  materials provided with the distribution.
;
;* Neither the name of LADSoft nor the names of its
;  contributors may be used to endorse or promote products
;  derived from this software without specific prior
;  written permission of LADSoft.
;
;THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
;WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
;PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
;ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
;LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
;INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
;TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
;ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;
; Copyright (c) 2000 LADsoft
;
; David Lindauer, camille@bluegrass.net
;
	SECTION _TEXT BYTE CLASS=CODE USE32
	SECTION _DATA ALIGN=4 CLASS=DATA USE32
    [global ___code_seg_end]
___code_seg_end:
%include "..\copyrght.asm"
		db	" (i386/WIN32)"
	SECTION _BSS  ALIGN=4 CLASS=BSS USE32
		dd	0004E4957h
BssStart:
	SECTION _BSSEND_  ALIGN=4 CLASS=BSS USE32
BssEnd:
		dd	00044414ch
	SECTION _CONST  ALIGN=4 CLASS=CONST USE32
	SECTION _STRING  ALIGN=4 CLASS=STRING USE32
	SECTION cstartup ALIGN=4 CLASS=INITDATA USE32
InitStart:
	SECTION _STARTUPEND_ ALIGN=4 CLASS=INITDATA USE32
InitEnd	dd	0
		dd	0
	SECTION crundown ALIGN=4 CLASS=EXITDATA USE32
ExitStart:
	SECTION _RUNDOWNEND_ ALIGN=4 CLASS=EXITDATA USE32
ExitEnd:
		dd	0
	SECTION cppinit  ALIGN=4 CLASS=CPPINIT USE32
CppStart:
		dd	cpproutine,130
	SECTION _CPPEND_  ALIGN=4 CLASS=CPPINIT USE32
CppEnd:
		dd	0
	SECTION cppexit  ALIGN=4 CLASS=CPPEXIT USE32
CpprStart:
	SECTION _CPPREND_  ALIGN=4 CLASS=CPPEXIT USE32
CpprEnd:
		dd	0

DGROUP group _DATA,cstartup,_STARTUPEND_,crundown,_RUNDOWNEND_,cppinit,_CPPEND_,_BSS,_BSSEND_

	SECTION _DATA
	align 4
[export __oscmd]
[global __oscmd]
[global __osenv]
[export __hinstance]
[global __hinstance]
[global __isDLL]
[global __win32]
[global ___runproc]
[export ___runproc]
__oscmd		dd	0
__osenv		dd	0
__hinstance	dd	0
__win32		dd	1
;xcptsv1		dd	0
;xcptsv2		dd	0
;xcptp1          dd      0
;xcptp2          dd      0
;espsave         dd      0
dllexists	dd	0
__isDLL         dd      1
nError		db	"Error",0
nNonSharedDataSeg db	"NonShared data segment required",0
userrundown dd  0

SECTION	_TEXT
;
; C startup procedures
;
[global ___code_seg_start]

___code_seg_start:
..start:
		push	ebp
		mov	ebp,esp
		push	esi
		push	edi
		push	ebx

		cmp	dword [ebp+12],1
		jnz	ndll1
		cmp	dword [dllexists],0
		jz	cdll1
		push	0
		push	nError
		push	nNonSharedDataSeg
		push	0
		extern	MessageBoxA
		call	MessageBoxA
		sub	eax,eax
		jmp	dllfin
cdll1:
		inc 	dword [dllexists]		
				

ndll1:

;
; Call main
;
                push    dword [ebp+16]
		push	dword [ebp+12]
                push    dword [ebp+8]
    	extern	DllEntryPoint 
		call	DllEntryPoint
        test    dword [ebp+12],-1
        jnz     dllfin
        ; process detach if we get here
dllfin:
		pop	ebx
		pop	edi
		pop	esi
		mov	esp,ebp
		pop	ebp
		ret	12
;
; Handle startup/rundown routines
;
___runproc:
sexproc:
		cmp	ecx,edx		
		jz	short sexpdone	
		mov	edi,ecx
		sub	ebx,ebx
		sub	eax,eax
spl2:
		cmp	edi,edx
		jz	short spo
		test	dword [edi+4],-1
		jz	short spl3
		cmp	eax,[edi+4]
		jnc	short spl3
		mov	ebx,edi
		mov	eax,[edi+4]
spl3:
		add	edi,8
		jmp	spl2
spo:
		or	ebx,ebx
		jz	short sexpdone
		mov	dword [ebx+4],0
		push	edx
		push	ecx
		call	[ebx]
		pop	ecx
		pop	edx
		jmp	sexproc
sexpdone:
		ret
global ___lsdllinit
export ___lsdllinit        
___lsdllinit:
        mov [userrundown],eax
		mov [__win32],edx
		push ecx ; arg for llxceptinit
		
		extern GetEnvironmentStrings 
		call  GetEnvironmentStrings
		mov   [__osenv],eax

		extern GetCommandLineA 
		call  GetCommandLineA
		mov   [__oscmd],eax

		extern GetModuleHandleA 
		push	0
		call  GetModuleHandleA
		mov   [__hinstance], eax

;
; not used right now, may use it later...
;
;		mov	edx,[fs:4]
;		mov	eax,[edx-4]
;		mov	[xcptsv1],eax
;		mov	eax,[edx-8]
;		mov	[xcptsv2],eax
;                sub     edx,4
;                mov     [xcptp1],edx
;                mov     dword [edx],0
;                sub     edx,4
;                mov     [xcptp2],edx
;                mov     dword [edx],0
;                mov     [espsave],esp
;                cmp     esp,edx
;                jb      noadjesp
;                mov     esp,edx
noadjesp:
		extern  __llfpinit
		call   __llfpinit
		
		extern	__xceptinit 
		; arg pushed above
		call	__xceptinit
;
; Execute startup routines
;
		mov	ecx,InitStart
		mov	edx,InitEnd
		call	sexproc
		cld
;
; Execute C++ class initializers
;
		mov	ecx,CppStart
		mov	edx,CppEnd
		call	sexproc
		cld
ndll2:
        ret
; exit/abort comes here
;
[global __rexit]
[global __rexita]
__rexit:
		push	eax		; saving C return code
        test    dword [userrundown],-1
        jz _rc
        call [userrundown]    
_rc:                

;
; Execute C++ class rundown routines
;
		cld
		mov	ecx,CpprStart
		mov	edx,CpprEnd
		call	sexproc
;
; Execute rundown routines
;
		mov	ecx,ExitStart
		mov	edx,ExitEnd
		call	sexproc
                pop     eax
__rexita:
;                mov     esp,[espsave] 
                push    eax         
;		mov	edx,[fs:4]
;                mov     ecx,[xcptsv1]
;                mov     [edx-4],ecx
;                mov     ecx,[xcptsv2]
;                mov     [edx-8],ecx
		extern	__xceptrundown 
		call	__xceptrundown

	extern   ExitProcess 
	call	ExitProcess ; return code already on stack
    ; never get here
; This is called as the first thing from the C++ main routine
cpproutine:
		ret

